#include <exec/types.h>
#include <exec/libraries.h>
#include <exec/memory.h>
#include <graphics/gfxbase.h>
#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <datatypes/datatypesclass.h>
#include <datatypes/pictureclass.h>
#include <datatypes/textclass.h>
#include <libraries/gadtools.h>
#include <intuition/intuitionbase.h>
#include <intuition/gadgetclass.h>
#include <intuition/icclass.h>
#include <intuition/imageclass.h>
#include <workbench/workbench.h>
#include <workbench/startup.h>
#include <proto/exec.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/gadtools.h>
#include <proto/utility.h>
#include <proto/wb.h>
#include <proto/dos.h>
#include <clib/datatypes_protos.h>
#define AMIGAOS_V_39  39
struct Library *GadToolsBase, *UtilityBase,
                   *WorkbenchBase, *DataTypesBase;
extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase *GfxBase;
void DisposeWindow(struct Window *w) {
  struct Gadget *g = w->FirstGadget;
  CloseWindow(w); FreeGadgets(g);
}
#define W_SPACE   4
#define W_WIDTH   600
#define W_HEIGHT  200
#define G_WIDTH   18
#define A_WIDTH   24
struct Gadget *g[2];
struct Window *InitWindow(void) {
APTR vi;  struct NewGadget ng;
struct Screen *ps;  struct Window *w;
struct Gadget *gl,*gad = NULL;
if(ps = LockPubScreen(NULL)) {
  if(vi = GetVisualInfoA(ps,NULL)) {
    if(gad = CreateContext(&gl)) {
      ng.ng_LeftEdge = ps->WBorLeft + W_SPACE;
      ng.ng_TopEdge = W_HEIGHT + ps->BarHeight
                        - W_SPACE - G_WIDTH;
      ng.ng_Width =W_WIDTH- W_SPACE*2-G_WIDTH;
      ng.ng_Height    = G_WIDTH;
      ng.ng_VisualInfo = vi;
      ng.ng_GadgetText = NULL;
      ng.ng_Flags=0L; ng.ng_TextAttr= ps->Font;
      ng.ng_GadgetID = 0; ng.ng_UserData = NULL;
      g[0] = (gad = CreateGadget(SCROLLER_KIND,
       gad,&ng, PGA_Freedom,(ULONG)LORIENT_HORIZ,
       GA_RelVerify,1L,GTSC_Arrows,(ULONG)A_WIDTH,
       TAG_DONE));
      ng.ng_LeftEdge = ps->WBorLeft + W_WIDTH -
                       G_WIDTH - W_SPACE;
      ng.ng_TopEdge   = ps->BarHeight + W_SPACE;
      ng.ng_Width     = G_WIDTH;
      ng.ng_Height    = W_HEIGHT - W_SPACE * 2;
      ng.ng_GadgetID   = 1;
      g[1] = (gad = CreateGadget(SCROLLER_KIND,
         gad,&ng,PGA_Freedom,(ULONG)LORIENT_VERT,
         GA_RelVerify,1L, GTSC_Arrows,
         (ULONG)A_WIDTH,TAG_DONE));
      if(w = OpenWindowTags(NULL,
        WA_Flags,(ULONG)WFLG_CLOSEGADGET|
          WFLG_DEPTHGADGET|WFLG_DRAGBAR|
          WFLG_ACTIVATE,
        WA_IDCMP,(ULONG)SCROLLERIDCMP|
          IDCMP_CLOSEWINDOW|IDCMP_IDCMPUPDATE,
        WA_InnerHeight,(ULONG)W_HEIGHT,
        WA_InnerWidth,(ULONG)W_WIDTH,
        WA_Gadgets,gl, WA_SmartRefresh,1L,
        WA_Title,"datatypes example",
        TAG_DONE)) {
        GT_RefreshWindow(w,NULL);
        DrawBevelBox(w->RPort,
          w->BorderLeft + W_SPACE,
          w->BorderTop + W_SPACE - 1,
          W_WIDTH - G_WIDTH - 3 * W_SPACE,
          W_HEIGHT - G_WIDTH - 3 * W_SPACE,
          GT_VisualInfo,vi, GTBB_FrameType,
          (ULONG)BBFT_ICONDROPBOX,TAG_DONE);
      } else FreeGadgets(gl);
    }
    FreeVisualInfo(vi);
  }
  UnlockPubScreen(NULL,ps);
}
return(w);
}
void CloseLibs(int n) {
  switch(n) {
    case 0: CloseLibrary(&GfxBase->LibNode);
    case 1: CloseLibrary(UtilityBase);
    case 2: CloseLibrary(DataTypesBase);
    case 3: CloseLibrary(GadToolsBase);
    case 4: CloseLibrary(&IntuitionBase->LibNode);
    case 5: CloseLibrary(WorkbenchBase);
    default:  break;
  }
}
int OpenLibs(void) {
  if(WorkbenchBase = OpenLibrary
    ("workbench.library",0L)) {
    if(IntuitionBase = (struct IntuitionBase*)
    OpenLibrary("intuition.library",0L)) {
      if(GadToolsBase = OpenLibrary
      ("gadtools.library",0L)) {
        if(DataTypesBase = OpenLibrary
        ("datatypes.library",AMIGAOS_V_39)) {
          if(UtilityBase = OpenLibrary
          ("utility.library",0L)) {
            if(GfxBase = (struct GfxBase*)
            OpenLibrary("graphics.library",0L)) {
              return(1);
            } else CloseLibs(1);
          } else CloseLibs(2);
        } else CloseLibs(3);
      } else CloseLibs(4);
    } else CloseLibs(5);
  }
  return(0);
}
void main(int argc, unsigned char *argv[]) {
struct MsgPort *amp;
struct AppWindow *awin;
struct Window *w;
int done = FALSE;
APTR newdtobj,dtobj = NULL;
if(OpenLibs()) {
 if(amp = CreateMsgPort()) {
  if(w = InitWindow()) {
   if(awin=AddAppWindow(0,NULL,w,amp,NULL)) {
    while(!done) {
     ULONG sigRcvd;
     sigRcvd=Wait(1L<<w->UserPort->mp_SigBit
                 |1L<<amp->mp_SigBit);
     if(sigRcvd & (1L << amp->mp_SigBit)) {
       struct AppMessage *amsg;
       while(amsg=(struct AppMessage*)GetMsg(amp)){
         BPTR oldcd;
         struct WBArg *aptr=amsg->am_ArgList;
         if(oldcd=CurrentDir(aptr->wa_Lock)){
           if(newdtobj = NewDTObject(
                    aptr->wa_Name,TAG_END)) {
             if(dtobj) {
               RemoveDTObject(w,dtobj);
               DisposeDTObject(dtobj);
               SetAPen(w->RPort,0);
               RectFill(w->RPort,
               w->BorderLeft + W_SPACE+6,
               w->BorderTop + W_SPACE-1+3,
               w->BorderLeft + W_SPACE+6+W_WIDTH-
                G_WIDTH-3*W_SPACE-12-1,
               w->BorderTop+W_SPACE-1+3+W_HEIGHT-
                G_WIDTH-3*W_SPACE-6-1);
             }
             dtobj = newdtobj;
             SetDTAttrs(dtobj,NULL,NULL,
             GA_Left,(ULONG)w->BorderLeft+W_SPACE+6,
             GA_Top,(ULONG)w->BorderTop+W_SPACE-1+3,
             GA_Width,(ULONG)W_WIDTH-G_WIDTH
                      - 3 * W_SPACE - 12,
             GA_Height,(ULONG)W_HEIGHT-G_WIDTH-3*
                       W_SPACE-6,
             DTA_TextAttr,w->WScreen->Font,
             ICA_TARGET,ICTARGET_IDCMP,TAG_DONE);
             AddDTObject(w,NULL,dtobj,-1L);
             RefreshDTObjects(dtobj,w,NULL,NULL);
           }
           CurrentDir(oldcd);
         }
         ReplyMsg(&amsg->am_Message);
       }
     }
     if(sigRcvd & (1L<<w->UserPort->mp_SigBit)) {
       struct IntuiMessage *imsg;
       while(imsg=GT_GetIMsg(w->UserPort)){
         ULONG im_code,im_class;
         APTR im_address;
         struct TagItem *tstate,*tag,*tags;
         ULONG tidata,errnum,totWidth, totHeight,
               visWidth,visHeight,topEdge,leftEdge;
         im_class=imsg->Class;im_code=imsg->Code;
         im_address = imsg->IAddress;
         GT_ReplyIMsg(imsg);
         switch(im_class) {
           case IDCMP_IDCMPUPDATE:
             tstate=tags= (struct TagItem*)
                                im_address;
             while (tag=NextTagItem(&tstate)) {
               tidata = tag->ti_Data;
               switch(tag->ti_Tag) {
                 case DTA_Busy: /* Beschftigt */
                   if(tidata)SetWindowPointer(w,
                      WA_BusyPointer,1L,TAG_DONE);
                   else SetWindowPointer(w,
                      WA_Pointer,0L,TAG_DONE);
                   break;
                 case DTA_ErrorLevel: /* Error */
                   if (tidata) {
                     errnum = GetTagData(
                       DTA_ErrorNumber,0L,tags);
                   }
                   break;
                 case DTA_Sync: /* Refresh */
                   RefreshDTObjects(dtobj,
                                    w,NULL,NULL);
                   GetDTAttrs(dtobj,
                   DTA_TotalHoriz,&totWidth,
                   DTA_TotalVert,&totHeight,
                   DTA_VisibleHoriz,&visWidth,
                   DTA_VisibleVert,&visHeight,
                   DTA_TopHoriz,&leftEdge,
                   DTA_TopVert,&topEdge,
                   TAG_DONE);
                   GT_SetGadgetAttrs(g[0],w,NULL,
                   GTSC_Top,leftEdge,
                   GTSC_Total,totWidth,
                   GTSC_Visible,visWidth,
                   TAG_DONE);
                   GT_SetGadgetAttrs(g[1],w,NULL,
                   GTSC_Top,topEdge,
                   GTSC_Total,totHeight,
                   GTSC_Visible,visHeight,
                   TAG_DONE);
                   break;
               }
             }
             break;
           case IDCMP_MOUSEMOVE:
           case IDCMP_GADGETUP:
             if(!dtobj) break;
             switch(((struct Gadget*)
               im_address)->GadgetID) {
               case 0: /* Horiz */
                 SetDTAttrs(dtobj,w,NULL,
                 DTA_TopHoriz,im_code,TAG_DONE);
                 break;
               case 1: /* Vert */
                 SetDTAttrs(dtobj,w,NULL,
                 DTA_TopVert,im_code,TAG_DONE);
                 break;
               default: break;
             }
             break;
           case IDCMP_CLOSEWINDOW:
             if(dtobj) {
               RemoveDTObject(w,dtobj);
               DisposeDTObject(dtobj);
             }
             done = TRUE; break;
           default: break;
         }
       }
     }
    }
    RemoveAppWindow(awin);
   }
   DisposeWindow(w);
  }
  DeleteMsgPort(amp);
 }
 CloseLibs(0);
}
}
